# Installation

There are a few ways you can install Crunch, depending on your needs. Pre-compiled nightly builds are provided
for Windows and Linux, but the tool can be compiled for other platforms using other install methods

## Pre-built Binaries

Crunch is automatically built for Windows and Linux when changes are merged to the tracking branch, pass
tests, and compiles successfully. These binaries contain the latest updates, and may differ slightly from
these docs:

- [Latest version for Windows](https://lab.lcr.gr/microhacks/crunch/-/jobs/artifacts/trunk/raw/target/x86_64-pc-windows-gnu/release/crunch.exe?job=build-windows)
- [Latest version for Linux](https://lab.lcr.gr/microhacks/crunch/-/jobs/artifacts/trunk/raw/target/release/crunch?job=build-linux)

## Via Cargo

To install via Cargo, you will need a stable rust toolchain installed. You can install one with [Rustup](https://rustup.rs/).
Installation using this method will install the latest stable published version, which will correlate with these docs.

`cargo install crunch-cli`

## From Source

You can get a copy of the GPL-3.0 licensed Crunch source code from [Microhacks Labs](https://lab.lcr.gr/microhacks/crunch),
and compile it yourself. As with the Cargo installation method, you will need a stable rust toolchain.

```bash
git clone https://lab.lcr.gr/microhacks/crunch.git crunch
cd crunch
cargo build --release
cp target/release/crunch /some/path/entry
```